&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME Dialog-Frame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Dialog-Frame 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE DIALOG-BOX

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME Dialog-Frame

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS iText HowTo Btn_OK jText 
&Scoped-Define DISPLAYED-OBJECTS iText HowTo jText 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
DEFINE BUTTON Btn_OK AUTO-GO 
     LABEL "Game over" 
     SIZE 15 BY 1.14
     BGCOLOR 8 FONT 1.

DEFINE VARIABLE iText AS CHARACTER FORMAT "X(256)":U INITIAL "Hello World !" 
     VIEW-AS FILL-IN 
     SIZE 81.4 BY 1.05 TOOLTIP "Enter your text here."
     FONT 0 NO-UNDO.

DEFINE VARIABLE jText AS CHARACTER FORMAT "X(256)":U 
      VIEW-AS TEXT 
     SIZE 81.4 BY 1.05
     BGCOLOR 15 FGCOLOR 9  NO-UNDO.

DEFINE VARIABLE HowTo AS CHARACTER 
     VIEW-AS RADIO-SET HORIZONTAL
     RADIO-BUTTONS 
          "Right", "R",
"Center", "C"
     SIZE 37 BY 1.1
     FONT 6 NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME Dialog-Frame
     iText AT ROW 1.67 COL 2 COLON-ALIGNED NO-LABEL
     HowTo AT ROW 3.24 COL 4.6 NO-LABEL
     Btn_OK AT ROW 6.67 COL 71.6
     jText AT ROW 4.91 COL 4 NO-LABEL
     SPACE(1.79) SKIP(2.17)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         FONT 20
         TITLE "Justification example"
         DEFAULT-BUTTON Btn_OK.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: DIALOG-BOX
   Allow: Basic,Browse,DB-Fields,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS


/* ***************  Runtime Attributes and UIB Settings  ************** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX Dialog-Frame
                                                                        */
ASSIGN 
       FRAME Dialog-Frame:SCROLLABLE       = FALSE
       FRAME Dialog-Frame:HIDDEN           = TRUE.

/* SETTINGS FOR FILL-IN jText IN FRAME Dialog-Frame
   ALIGN-L                                                              */
/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 




/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME Dialog-Frame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Dialog-Frame Dialog-Frame
ON WINDOW-CLOSE OF FRAME Dialog-Frame /* Justification example */
DO:
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME HowTo
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL HowTo Dialog-Frame
ON VALUE-CHANGED OF HowTo IN FRAME Dialog-Frame
DO:
  Run RunJustify.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME iText
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL iText Dialog-Frame
ON ANY-KEY OF iText IN FRAME Dialog-Frame /* Text */
DO:
  Apply Lastkey.
  Run RunJustify.
  Return no-apply.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Dialog-Frame 


/* ***************************  Main Block  *************************** */

/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */
IF VALID-HANDLE(ACTIVE-WINDOW) AND FRAME {&FRAME-NAME}:PARENT eq ?
THEN FRAME {&FRAME-NAME}:PARENT = ACTIVE-WINDOW.


/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  
  Run RunJustify.
  
  WAIT-FOR GO OF FRAME {&FRAME-NAME}.
END.
RUN disable_UI.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI Dialog-Frame _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME Dialog-Frame.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI Dialog-Frame _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY iText HowTo jText 
      WITH FRAME Dialog-Frame.
  ENABLE iText HowTo Btn_OK jText 
      WITH FRAME Dialog-Frame.
  VIEW FRAME Dialog-Frame.
  {&OPEN-BROWSERS-IN-QUERY-Dialog-Frame}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE Justify Dialog-Frame 
PROCEDURE Justify :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEF INPUT PARAMETER hWidget  		as HANDLE no-undo.
DEF INPUT PARAMETER TextToJustify		as CHAR   no-undo.  
DEF INPUT PARAMETER HowTo			as CHAR no-undo.

Def var     hParent         as Handle 	no-UNDO.
Def var     fontNumber      as Int    	no-UNDO  initial ?.
Def var     textWidth       as int		no-UNDO.
Def var     fillWidth       as int		no-UNDO.

/*	Get the widget font number */   
     
If hWidget:FONT = ? then do :
        hParent = hWidget:PARENT.
        Do while(valid-Handle(hParent)
                 and (NOT can-query(hParent, "FONT")
                      OR hParent:FONT = ?)) :
                 hParent = hParent:PARENT.
                 end.
                 
        If valid-handle(hParent)
        and hParent:FONT <> ? then 	/* The parent has no font value ! */
			fontNumber = hParent:FONT.
        end.
else
        fontNumber = hWidget:FONT.

/*	Assume that fill char is space */        
&SCOP	Sep	" "

/*	Get width of text and fill char */
if fontNumber = ? then
    ASSIGN         
            textWidth  = FONT-TABLE:GET-TEXT-WIDTH-PIXELS(TextToJustify)
            fillWidth  = FONT-TABLE:GET-TEXT-WIDTH-PIXELS({&Sep}).      
else  
            ASSIGN textWidth  = FONT-TABLE:GET-TEXT-WIDTH-PIXELS(TextToJustify, fontNumber).
                   fillWidth  = FONT-TABLE:GET-TEXT-WIDTH-PIXELS({&Sep},        fontNumber).

/* If HowTo = "C" then a centered text will be displayed, otherwise a right justify
   occurs.
*/
HWidget:SCREEN-VALUE =
                        Fill({&Sep},
                             MAX(
                                 INT(TRUNCATE( (hWidget:WIDTH-PIXELS - textWidth) / fillWidth
             / (If HowTo = "C" then 2 else 1)  
, 0  ) 
                                     )
                                 , 0)
                            )
                        + TextToJustify.  
 

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE RunJustify Dialog-Frame 
PROCEDURE RunJustify :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  Assign Frame {&FRAME-NAME} Howto iText.
  Run Justify(jText:handle, iText, Howto).
  
  END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


